//+------------------------------------------------------------------+
//|                                                   RoboSlider.mq4 |
//|                                                                  |
//|                        Mod  Steve Watkins - nituser4u@gmail.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, niteuser4u@gmail.com"
#property link      ""


#include <stdlib.mqh>
#include <stderror.mqh>
#define  NL    "\n"
#define MAGIC 1828212
extern double TakeProfit = 1200;
extern double StopLoss = 110;
extern double TrailingStop = 20;
extern double Lots = 0.1;
extern int Slippage = 7;
extern string Name_Expert = "RoboSlider";
extern int     InitialAccount = 2000;
extern bool UseJuice=true;
extern int     Juice.TimeFrame=30;                                 // time frame for juice. Should be in accordance with trigger.period
extern int     Juice.Period=7;                                    // Juice Period
extern int     Juice.Level=4; 
int            Order                   = 0;
double CurrentJuice;   // From Juice
bool FlatMarket;
bool EntryAllowed=false;
bool FirstFlatMarket;
bool OK2Buy, OK2Sell; 
extern double  IncreaseFactor = 0.03;
int lotPrecision;
double lotMM;
double lotMB;
extern double Risk = 0.2;
double mymainrisk = 0.2;
extern int     Accounttype             = 10;
double         PortionBalance, PortionEquity;
int            BrokerDecimal           = 1;
datetime       LastOrderDateTime = 0;
 
void deinit() {
   Comment("");
  
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void init(){
EntryAllowed= false;
mymainrisk = Risk;
}

int start(){

 FlatMarket = false;
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(StopLoss<8){
      Print("StopLoss less than 10");
      return(0);
   }
   
int cnt, ticket, total;
   
   double RSI=iRSI(NULL,0,21,PRICE_CLOSE,0);
   double Price = iOpen(Symbol(), NULL, 0);
   double trendis=iCustom(NULL,0,"trenddetect",0,1,0);
   double Trigger=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,0);
   double MA1=iMA(NULL,0,18,0,MODE_EMA,PRICE_CLOSE,0);
   double MA2=iMA(NULL,0,28,0,MODE_EMA,PRICE_CLOSE,0);
   string mynumis=DoubleToStr(trendis,4);
   
   
   //if(AccountFreeMargin()<(1*Lots)){
   //   Print("We have no money. Free Margin = ", AccountFreeMargin());
   //   return(0);
  // }
   //////////////////////////////////////////////////////////////////////////////////////////////
//bof-LOT BRAIN  WHAT MAKES ANY EA WORK BETTER  (c) Steven Michael Watkins(c), Secured Party//
//////////////////////////////////////////////////////////////////////////////////////////////
if (Risk > 0.0) Lots = MMLots(Risk);
   
   
   lotMM = LotsOptimized(1828212);
   lotMB = AutoLot(Lots);
   TrailingPositionsBuy(TrailingStop);
   TrailingPositionsSell(TrailingStop);

////////////Notes on this function want to find a way to count up or down to tell if indi is going
////////////up or down changing this can make or break results. lets find something that works here///

   if (mynumis == "0.0006" || mynumis == "-0.0006"){ EntryAllowed= true; Print ("New Entry Allowed"); }
   if (mynumis == "0.0012" || mynumis == "-0.0012"){ EntryAllowed= true; Print ("New Entry Allowed"); }
   if (mynumis == "0.0018" || mynumis == "-0.0018"){ EntryAllowed= true; Print ("New Entry Allowed"); }
   if (mynumis == "0.0024" || mynumis == "-0.0024"){ EntryAllowed= true; Print ("New Entry Allowed"); }
////////////////////////////////////////////////        
          if (UseJuice)
          {
         // Check Juice filter for flat market

         CurrentJuice = Juice(1, Juice.Period, Juice.Level,Juice.TimeFrame);
     
      // is juice ok for trading?          
         if (CurrentJuice<=0)
         { 
         OK2Buy = false;
         OK2Sell = false;
         FlatMarket = true;
         FirstFlatMarket = false;
         }
         }
         if (FlatMarket && !FirstFlatMarket)
         {
         FirstFlatMarket = true;
            
        // Print ("Filter says Market is flat" + CurrentJuice);
          
       
         }
         if (FlatMarket) return (0);
   
  // -----------------+

//////dont let orders open back to back
if(CheckJustClosedOrder()==1) {Print("Flag Thrown");return(0);}
////////
   
   if (!ExistPositions() && EntryAllowed){
   
     
        ///trying a few things here
        //if ((Price>Trigger) && (MA1>MA2) && (trendis<0)){
        if ((trendis<0)){ 
         ticket = OrderSend(Symbol(),OP_BUY, lotMB ,Ask, 3, Ask - (StopLoss*Point), 
                               Ask + (TakeProfit*Point), "RoboSlider", 1828212, 0, Green);
        EntryAllowed = false;
        return(0);
        if(OrderType()==OP_BUY)
        {
         if(MA1<MA2) OrderClose(OrderTicket(),OrderLots(),Bid,3,Lime);
           }
           return(0);
        }


        //if ((Price<Trigger) && (MA1<MA2) && (trendis>0)){
        if ((trendis>0)){
         ticket = OrderSend(Symbol(), OP_SELL, lotMB ,Bid, 3, Bid + (StopLoss*Point), 
                               Bid - (TakeProfit*Point), "RoboSlider", 1828212, 0, Red);
         EntryAllowed = false;
         return(0);
         if(OrderType()==OP_SELL)
        {
         if(MA1>MA2) OrderClose(OrderTicket(),OrderLots(),Ask,3,Lime);
         
        }
      }
   
}
   
   return (0);
}
bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}
void TrailingPositionsBuy(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_BUY) { 
               if (Bid-OrderOpenPrice()>trailingStop*Point) { 
                  if (OrderStopLoss()<Bid-trailingStop*Point) 
                     ModifyStopLoss(Bid-trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void TrailingPositionsSell(int trailingStop) { 
   for (int i=0; i<OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) { 
            if (OrderType()==OP_SELL) { 
               if (OrderOpenPrice()-Ask>trailingStop*Point) { 
                  if (OrderStopLoss()>Ask+trailingStop*Point || OrderStopLoss()==0)  
                     ModifyStopLoss(Ask+trailingStop*Point); 
               } 
            } 
         } 
      } 
   } 
} 
void ModifyStopLoss(double ldStopLoss) { 
   bool fm;
   fm = OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);  
}
 

return(0);


//////////////////////////////////////////////////////////////////////////////////////////
//bof-LOT BRAIN  WHAT MAKES ANY EA WORK BETTER  (c) Steven Michael Watkins(c)           //
//////////////////////////////////////////////////////////////////////////////////////////
double LotsOptimized(int Mnr)
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
   int    mywins=0;
//---- select lot size
  
//---- calcuulate number of losses orders without a break
   if(IncreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Mnr) continue;
         //----
         if(OrderProfit()>2) break;
         if(OrderProfit()<0) losses++;
        }
      for(i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=Mnr) continue;
         //----
         if(OrderProfit()<2) break;
         if(OrderProfit()>0) mywins++;
        }
     //LIGHT RECOVERY MODE ATTEMPT TO RETAIN PROFITS
        /////Change to effect ea lot sizes based on wins ---losses
        //Print(losses+" wins: "+mywins);
        //if(mywins == 1) { Risk=Risk/2; }
        //if(mywins > 1) { Risk=mymainrisk; }
        //if(mywins > 3) { Risk=Risk/2; }
        //if(mywins == 0) { Risk=mymainrisk; }
        //if(losses == 1) { Risk=mymainrisk;lot=NormalizeDouble(lot + (IncreaseFactor * losses), 2); }
        //if(losses == 2) { Risk=Risk/2; }
        //if(losses > 2) { Risk=Risk/2; }
        
      double PortionBalancetrade, InitialAccountMultiPortion;
 
      PortionBalancetrade = NormalizeDouble(AccountBalance(),2);
      InitialAccountMultiPortion = InitialAccount;
      
      if (PortionBalancetrade < InitialAccountMultiPortion){ 
      lot=Lots;
      //AGRESSIVE RECOVERY WARNING 
      
      
      //Print(PortionBalancetrade,InitialAccountMultiPortion,losses);
        //if(mywins == 1) { Risk=Risk/2; }
        //if(mywins > 1) { Risk=mymainrisk; }
        //if(mywins > 3) { Risk=Risk/2; }
        //if(mywins == 0) { Risk=mymainrisk; }
        //if(losses == 1) { Risk=mymainrisk;lot=NormalizeDouble(lot + (IncreaseFactor * losses), 2); }
        //if(losses == 2) { Risk=Risk/2; }
        //if(losses > 2) { Risk=Risk/2; }
        
      }

//     if (PortionBalancetrade > InitialAccountMultiPortion){ 
     // InitialAccount = NormalizeDouble(AccountBalance(),2);
     /// Print(InitialAccount);
      } 
 //    }
  
  // Check if standard Account - activate for later uses
  
 // if(AccountIsMini==1)
 // {
 //     lot = MathFloor(lot);
 //     lot = lot / 10;
    
// Use at least 1 mini lot

//   if(lot<0.1) lot=0.1;}
//    else{
//    if (lot < 1.0) lot = 1.0;
//    if (lot > 100) lot = 100;
//  }

   return(lot);
  }
  

double MMLots(double ad_0) {
   return (NormalizeLots(ad_0 * AccountFreeMargin() / MarketInfo(Symbol(), MODE_MARGINREQUIRED) / (AccountLeverage() / 100.0)));
}

double NormalizeLots(double ad_0) {
   double l_lotstep_8 = MarketInfo(Symbol(), MODE_LOTSTEP);
   double l_minlot_16 = MarketInfo(Symbol(), MODE_MINLOT);
   double l_maxlot_24 = MarketInfo(Symbol(), MODE_MAXLOT);
   double ld_ret_32 = MathCeil(ad_0 / l_lotstep_8) * l_lotstep_8;
   if (ld_ret_32 < l_minlot_16) ld_ret_32 = l_minlot_16;
   if (ld_ret_32 > l_maxlot_24) ld_ret_32 = l_maxlot_24;
   return (ld_ret_32);
}

double AutoLot(double lotR)
  {
 
   
//lotR=NormalizeDouble(Accounttype*((AccountBalance()/10000)*(MaximumRisk/100))/Portion,lotPrecision);
   
//Determine Lot size boundries from minimum to maximum   
//Number based on max lots at the 16 total order Point
//This allows for continued trading with large amounts
//Will keep from getting ordersend error 131 on large accounts
//Standard 100/17 = 5.88
//Micro 50/17 = 2.94
   
   if(lotR<0.01) lotR=0.01;
   if(lotR < MarketInfo(Symbol(),MODE_MINLOT)) lotR = MarketInfo(Symbol(),MODE_MINLOT);
   if(lotR>5.88 && Accounttype == 1) lotR=5.88;
   if(lotR>2.94 && Accounttype == 10) lotR=2.94;
  
   return(lotR);
  }


//+------------------------------------------------------------------+

double Juice(int shift, int period, int level, int jtimeframe)
{  double osma= 0;
   osma= iStdDev(NULL,jtimeframe, period, MODE_EMA, 0, PRICE_CLOSE,shift) - level*Point;
   return (osma);
}

int CheckJustClosedOrder()
{
int cnt;
datetime orderclosetime, rightnow;
int      TheHistoryTotal=OrdersHistoryTotal();
int      flag=0;
   for(cnt=0;cnt<TheHistoryTotal;cnt++) 
    {
    if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
       {
        if ( (OrderSymbol()==Symbol()) && (OrderMagicNumber()==MAGIC) )      
            {
               orderclosetime=OrderCloseTime();
               rightnow=CurTime();
               if(rightnow-orderclosetime<16000) 
                  { // At least 10jam away!
                   flag=1;   // Throw a flag tanda tidak boleh open
                   break;
                  }
              }
         }
     }
     return(flag);
}